CompilerIf Defined(__basic_procedures__, #PB_Constant) = 0
  
  #__basic_procedures__ = #True
  
;Here are some very basic procedures 
;maybe splittet later on, for seperate themes (GFX/Sprite/Font/whatever)

; -----------------------------------------------------------------------------
; - lID =  GetNextID() 
; -----------------------------------------------------------------------------
; - Description:
; - Creates a new ID - based on a static value, added each call and returned
; - 
; -----------------------------------------------------------------------------
; - Returns:
; - a new ID (as Long)
; -----------------------------------------------------------------------------

Procedure.l GetNextID() 
  Static id.l;
  id+1
  ProcedureReturn id
EndProcedure

;---- in cinclude!

; Zoom und Rotate und Display von einem Sprite3D
; ----------------------------------------------
; Sprite - Nummer des Anzuzeigenen Sprite
; x      - X-Positon des Mittelpunks bzw. Rotationspunkts vom Sprite
; y      - Y-Positon des Mittelpunks bzw. Rotationspunkts vom Sprite
; xx     - Breite des Sprite
; yy     - Hhe des Sprite
; w      - Rotationswinkel des Sprite (in Grad, wobei 0 Richtung Osten ist)
; dx     - Verschiebt den Mittelpunkt und damit auch den Rotationspunkt
;          auf dem Sprite in X-Richtung
; dy     - Verschiebt den Mittelpunkt und damit auch den Rotationspunkt
;          auf dem Sprite in Y-Richtung
; h      - Transparenz des Sprite (0 Transparent, 255 voll sichtbar)

Procedure DisplayZoomRotateSprite3D(Sprite, x, y, xx, yy, w.f, dx, dy, h)
  ;anti-center....
  x + (xx/2)
  y + (yy/2)
  
  w = w * (#PI/180)
  r.f = Sqr(Pow(xx,2)+Pow(yy,2))/2
  t.f = ATan(xx/yy)
  w1.f = w       - t : w2.f = w       + t : w3.f = w + #PI - t : w4.f = w + #PI + t
  TransformSprite3D(Sprite, Cos(w1)*r, Sin(w1)*r, Cos(w2)*r, Sin(w2)*r, Cos(w3)*r, Sin(w3)*r, Cos(w4)*r, Sin(w4)*r)
  DisplaySprite3D(Sprite, x-Cos(w)*dy+Sin(w)*dx, y-Sin(w)*dy-Cos(w)*dx, h)
EndProcedure

;usefull for negative numbers
Procedure.d RandF (min.f,max.f)
  range.d = max-min
  precision.d =  $7FFFFFFF/range
  ProcedureReturn (Random(range*precision)+min*precision)/precision
EndProcedure

Procedure Min(a,b)
  If a > b
    ProcedureReturn b
  Else   
    ProcedureReturn a
  EndIf
EndProcedure

Procedure Max(a,b)
  If a < b
    ProcedureReturn b
  Else
    ProcedureReturn a
  EndIf
EndProcedure



; ------

; Diese Funktion ist fr dich irrelevant.
; Sie wird nur von andern Funktionen verwendet.
Procedure.s LoadContent (sURL.s , sScript.s , sArguments.s, sDefaultCode.s)
  ;                            |         |             |           
  ;                            |         |             |                     
  ;                            |         |             |                               
  ;                            |         |             |______ Argumente die an das Script gesandt werden sollen.
  ;                            |         |______ Dateinamen des Scripts das den Query empfangen soll.
  ;                            |_____ Url zum Host. HTTP:// und dergleichen weglassen.       
  Protected lConID      .l
  Protected lPort       .l = 80
  Protected sHTTPHeader .s
  Protected sOutput     .s
  Protected lTimeout    .l
  Protected *Buffer 
  
  If Not sURL
    ProcedureReturn sDefaultCode
  EndIf
  
  If FindString (sURL , ":" , 1)
    lPort = Val (StringField (sURL , 2 , ":"))
    sURL  = StringField (sURL , 1 , ":")
  EndIf
  
  lConID = OpenNetworkConnection (sURL , lPort)
  If Not lConID
    ProcedureReturn sDefaultCode
  EndIf
  
  If sArguments
    sScript + "?" + sArguments
  EndIf
  
  sHTTPHeader + "GET " + sScript + " HTTP/1.1" + #CRLF$
  sHTTPHeader + "Host: " + sURL + #CRLF$
  sHTTPHeader + "Content-Type: application/x-www-form-urlencoded" + #CRLF$
  sHTTPHeader + "Connection: close" + #CRLF$
  sHTTPHeader + #CRLF$
  
  SendNetworkString(lConID , sHTTPHeader)
  
  lTimeout = ElapsedMilliseconds () + 1000
  While NetworkClientEvent(lConID) <> 2
    If lTimeout < ElapsedMilliseconds ()
      CloseNetworkConnection(lConID)
      ProcedureReturn sDefaultCode
    EndIf
    Delay(1)
  Wend
  
  *Buffer = AllocateMemory($FF)
  
  Repeat
    lBufferSize = ReceiveNetworkData (lConID, *Buffer, $FF)
    If Not (lBufferSize = #Null)
      sOutput + PeekS(*Buffer, lBufferSize)
    EndIf
  Until lBufferSize = #Null
  FreeMemory(*Buffer)
  CloseNetworkConnection(lConID)   
;  Debug("Received="+sOutput)
  
  ; lCutStart = FindString (sOutput , #CRLF$ + #CRLF$ , 1) + (SizeOf (CHARACTER) * 4)
  ; sOutput   = Right (sOutput , (Len(sOutput)-lCutStart) + SizeOf (CHARACTER))
  lCutStart = FindString (sOutput , "[BEGIN]" , 1) + Len("[BEGIN]")
  lCutEnd = FindString (sOutput , "[END]" , lCutStart)
  sOutput   =  Mid(sOutput, lCutStart, lCutEnd-lCutStart)
  ProcedureReturn sOutput
EndProcedure


CompilerEndIf

; jaPBe Version=3.8.2.693
; Build=0
; Language=0x0000 Language Neutral
; FirstLine=116
; CursorPosition=141
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF