; Prototype-Lib
; A Small Lib for fast prototyping.

IncludeFile "_basic_Macros.pbi"


Procedure prototypeInit(width.l, height.l, windowed=#False, name.s="protoType", depth.l=32 )
  
  DoOrDie("InitSprite() failed !",InitSprite())
  DoOrDie("InitSound() failed !",InitSound())
  DoOrDie("InitKeyboard() failed !",InitKeyboard())
  
  If windowed 
    DoOrDie("OpenWindow() failed !",OpenWindow(0, 0, 0, width,height,name , #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget ))
    DoOrDie("OpenWindowedScreen() failed !",OpenWindowedScreen(WindowID(0), 0, 0, width, height, 0,0,0 ))
  Else
    DoOrDie("InitMouse() failed !",InitMouse())
    DoOrDie("OpenScreen() failed !",OpenScreen(width,height,depth,name))
  EndIf
  DoOrDie("InitSprite() failed !",InitSprite3D())
EndProcedure
   
  
;CallBack synopsis: CallBack(timeDelta, MPOS.Point, MLC, MRC 
Procedure prototypeMain(*mainProc, backcolor.l=#Black, ShowCursor.l = #False)
  Define WinEventID.l
  Define ExitFlag.l = #False 
  Define HasFocus.l
  Define MPOS.POINT
  Define MLC.l,MRC.l
  Define nowTime.l, deltaTime.l
  Define time.l = ElapsedMilliseconds()
  
  Repeat 
    ExamineKeyboard()
    WinEventID   = WindowEvent()
    
    ;*** Focus-Test ***
    If Not IsScreenActive()
      HasFocus = #False
    Else
      HasFocus = #True
    EndIf
    
    ;*** Mouse Status ***
    If IsWindow(0)
      If WindowMouseX(0)>=0 And HasFocus
        MPOS\x = WindowMouseX(0)
        MPOS\y = WindowMouseY(0)
        MLC = GetAsyncKeyState_(#VK_LBUTTON)
        MRC = GetAsyncKeyState_(#VK_RBUTTON)
        If ShowCursor = #False
          ShowCursor_(0)
          ShowCursor = #True
        EndIf
      ElseIf ShowCursor = #True
        ShowCursor_(1)
        ShowCursor = #False
      EndIf
    Else
      ExamineMouse()
      MPOS\x = MouseX()
      MPOS\y = MouseY()
      MLC = MouseButton(#PB_MouseButton_Left)
      MRC = MouseButton(#PB_MouseButton_Right)
;      ShowCursor = #True 
    EndIf
    
    
    ;*****************************************************
    ;**** Focus-Check and NoFocus Display
    ;*****************************************************
    If Not HasFocus
      ClearScreen($404040)
      StartDrawing(ScreenOutput())
        DrawingMode(#PB_2DDrawing_Transparent)
        DrawText(100,100,"NoFocus",$C0C0C0)
      StopDrawing()
      Delay(100)
      ;*****************************************************
      ;**** Focus-Only
      ;*****************************************************
    Else
      ClearScreen(backcolor)
      
      ;CallBackup
      nowTime=ElapsedMilliseconds()
      deltaTime.l = nowTime-time
      time=nowTime
      
      ExitFlag = CallFunctionFast( *mainProc,  deltaTime, @MPOS, MLC , MRC)
      
      
      ;*** Mouse-Pointer Display ***
      If Not ShowCursor = #True
        StartDrawing(ScreenOutput())
          FrontColor($20C0C0)
          Line(MPOS\x   ,MPOS\y   , 24, 16)
          Line(MPOS\x   ,MPOS\y   , 16, 24)
          Line(MPOS\x+24,MPOS\y+16,-16, -8)
          Line(MPOS\x+16,MPOS\y+24, -8,-16) 
        StopDrawing()
      EndIf
      ;
      
      ;*** Escape - Test ***
      If KeyboardPushed(#PB_Key_Escape)
        ExitFlag = #True
      EndIf
      If WinEventID = #PB_Event_CloseWindow : ExitFlag=#True : EndIf
      ;
      
      ;*****************************************************
      ;**** E N D  of Focus-Only
      ;*****************************************************
    EndIf
    
    ;**************************************************************************
    ;**** M A I N - L O O P - E N D
    ;**************************************************************************
    FlipBuffers()
    
    CurrentTime = ElapsedMilliseconds()
    deltaTime = CurrentTime-LastTime
    If(deltaTime<16)
      Delay(17-deltaTime)
    EndIf
    LastTime = ElapsedMilliseconds()    
    
  Until ExitFlag = #True
  ;*************************************
  
EndProcedure



  
  
; jaPBe Version=3.8.2.693
; Build=0
; Language=0x0000 Language Neutral
; FirstLine=0
; CursorPosition=1
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF